--[[ 
	Author : CougarFFW04		11/2021

	Set aircraft group engine start time from ATO table
	
	par[1] is the ATO table name
	par[2] is used internaly in recursive mode
	par[3] is the minimum start time (generally set to timer.getTime())
	
	startATO calls startGroup function

	call :  startATO(blueATO, nil, timer.getTime())
-]]

function startATO(_ATO, _flight, _startT)
	
	for flight,param in pairs(_ATO) do
	
		if flight == 1 then flight = _flight end		
		local strChain, taskChain = flight, ""
		if param.task ~= nil then taskChain = param.task end
		
		if param.role == "Player" then 
			if Group.getByName(flight) then
				param.startT = _startT
				param.started = true	-- useless for players
				strChain = strChain.." (".._startT..") player enter game at "..SecondsToClock(param.startT)
			else
				param.prob = 0
			end
			
		elseif param.role == "IA" and param.started == false then
			-- if startup range not provided then defaulted to coalition
			if param.startup == nil or #param.startup == 0 then
				if Group.getByName(flight):getCoalition() == "RED" then
					param.startup = redStartRange
				else 
					param.startup = blueStartRange
				end
			end
			param.startT = math.max(timer.getTime()+ 15, _startT + math.random(param.startup[1],param.startup[2]))
			param.started = true
			strChain = strChain.."(IA - "..taskChain..") will stat at :"..SecondsToClock(_startT+param.startup[1]).." < "..SecondsToClock(param.startT).." < "..SecondsToClock(_startT+param.startup[2])
		else
			-- trigger.action.outText("DEBUG : "..strChain.." "..param.role.." not reconized or "..flight.." already started !!", 5)
			break
		end
		
		if param.prob == nil or (param.prob ~= nil and math.random(0,100) < param.prob) then	-- flight scheduled
			-- scheduling engine start
			if param.comms == nil or #param.comms == 0 then param.comms ={flight,nil,flight} end	-- dfault comms to coalition
			timer.scheduleFunction(startGroup,param.comms,param.startT)
			-- trigger.action.outText("DEBUG : "..strChain, 5)
			-- checking for packadge flights
			for f = 1, #param.flights do
				-- trigger.action.outText("DEBUG : "..param.flights[f].." "..param.startT,5)
				startATO({_G[param.flights[f]]},param.flights[f],param.startT)
			end			
		else	-- flight canceled
			-- trigger.action.outText("DEBUG : "..flight.." ("..param.role.." - "..taskChain..") CANCELED!!", 5)
		end
		
	end
end