--[[ 
	Author : CougarFFW04		11/2021

	Switching flag and group status mecanisism functions
-]]

-- DCS native function to call with timer.scheduleFunction
-- =======================================================
function mySetUserFlag(_par)
	-- par[1] : flagName and par[2] flagValue
	trigger.action.setUserFlag(_par[1], _par[2])
end

--[[
	switchFlag switches group flag status according to time delay and probability
	switchFlag calls switchStatus
	_grounds is a table as define for exemple in parameter file
	
	call : switchFlag(tabGroups)
	
	WARNING : MUST be called in a trigger CONTINU/NO RULES/EXECUTE SCRIPT switchFlag(tabGroups)
	======================================================================================
--]]

function switchFlag(_grounds)
	for group,typdel in pairs(_grounds) do
		groundFlag = group.."Flag"
		-- trigger.action.outText(group.." "..groundFlag.." "..typdel.pStop.." "..typdel.typ.." "..typdel.del[1].." "..typdel.del[2], 3)
		
		local iniFlag = trigger.misc.getUserFlag(groundFlag)
		if trigger.misc.getUserFlag(groundFlag) == 0 then
			trigger.action.setUserFlag(groundFlag,1)
			switchStatus({typdel.typ,_G[group],typdel.pStop})		
			timer.scheduleFunction(mySetUserFlag, {groundFlag, 0}, timer.getTime() + math.random(typdel.del[1], typdel.del[2]))
		end
		-- trigger.action.outText(group.." "..typdel.typ.." <"..iniFlag.."> "..trigger.misc.getUserFlag(groundFlag),3)
	end
end


--[[ 
	Switch ground vehicle move/stop or Sam on/off
	par[1] is the type of entity ("SAM" or "VEHICLE" supported)
	par[2] is a table (exemples : redSA2={Def="ON", Def1="ON"} or blueSupport = {convoi1="ON", convoi2="ON"})
	par[3] is the probability that entity is switched "off"/"stopped"

	call : switchStatus({"SAM",redSA2,10}) or switchStatus({"VEHICLE",bluSupport,20}) 
--]]

function switchStatus(_par)

	local _groupType = _par[1] 
    local _groups = _par[2]
    local _prob = _par[3]

    for group,status in pairs(_groups) do
		local chaine = "DEBUG: "
        local ran = math.random(0,100)
        chaine = chaine.."="..group.."= "..status.." || ".._prob.." "..ran

        if ran < _prob then
            chaine = chaine.." <OFF> "
            if status == "ON" then 
                _groups[group] = "OFF"
				if _groupType == "SAM" then
					-- Group.getByName(group):getController():setOnOff(false)
					Group.getByName(group):enableEmission(false)
					chaine = chaine..group.." radar emitter OFF !!"
				elseif _groupType == "VEHICLE" then
					Group.getByName(group):getController():setCommand({ id = 'StopRoute', params = {value = true} })
					chaine = chaine..group.. " STOPS !!"
				end
			end
		else
            chaine = chaine.." <ON> "
            if (status == "OFF" and math.random(1,5) <= 2) or (status ~= "ON" and status ~= "OFF")  then 
                _groups[group] = "ON"
				if _groupType == "SAM" then
					-- Group.getByName(group):getController():setOnOff(true)
					Group.getByName(group):enableEmission(true)
					chaine = chaine..group.." radar emiietr ON..."
				elseif _groupType == "VEHICLE" then
					Group.getByName(group):getController():setCommand({ id = 'StopRoute', params = {value = false} })
					chaine = chaine..group.." RESTARTS..."
				end
            end 
        end
        -- trigger.action.outText(chaine.." => ".._groups[group],5)
    end
end
